var ContentEngagePostPage = {

  postTitleInputID    : 'title',
  postTitleInputObject: {},

  titleWrapperID              : 'titlewrap',
  titleWrapperObject          : {},

  Init : function() {
    this.titleWrapperObject   = jQuery('#' + this.titleWrapperID);

    if(this.titleWrapperObject.length == 0)
      return;

    this.postTitleInputObject = jQuery('#' + this.postTitleInputID);

    if(titleList.length > 0) {
      this.InterfaceController.Init(this, titleList);
    } else {
      this.InitializationController.Init(this);
    }
  },

  InterfaceController : {

    _lang : {
      addInputButton   : 'Add another title',
      titlePlaceholder : 'Your desired title',
      removeOption     : 'Remove'
    },

    mainController    : {},

    containerID          : 'content-engage-interface-container',
    containerObject      : {},
    inputContainerID     : 'content-engage-interface-input-container',
    inputContainerObject : {},
    addInputID           : 'content-engage-interface-add-input',
    addInputObject       : {},

    inputGroupClass          : 'content-engage-interface-input-group',
    deletableInputGroupClass : 'content-engage-interface-deletable-input-group',
    deleteInputGroupClass    : 'content-engage-interface-delete-input-group',

    newFieldInputGroupName      : 'content_engage_field_new',
    existentFieldInputGroupName : 'content_engage_field_existent',

    existentEntries : [],

    Init : function(mainController, existentEntries) {
      this.mainController  = mainController;
      this.existentEntries = (typeof existentEntries === "undefined" ? [] : existentEntries);

      this._setContainer();

      if(this.existentEntries.length == 0) {
        this._addField(
            this.mainController.postTitleInputObject.val(),
            this.newFieldInputGroupName + '[]'
        );
      } else {
        this._existentInitialization();
      }

      var objectInstance = this;

      this.mainController.titleWrapperObject.fadeOut("slow", function(){
        objectInstance.containerObject.fadeIn("slow");
        objectInstance._arrangeFieldContainers();
      });


      jQuery(window).resize(function(){
        objectInstance._arrangeFieldContainers();
      });
    },

    _setContainer : function() {
      this.mainController.titleWrapperObject.after(
          '<div id="' + this.containerID + '" style="display:none;"></div>'
      );
      this.containerObject = jQuery("#" + this.containerID);

      this.containerObject.append(
          '<div id="' + this.inputContainerID + '"></div>'
      );
      this.inputContainerObject = jQuery("#" + this.inputContainerID);

      this.containerObject.append(
          '<span id="' + this.addInputID + '" class="button button-default right">' +
            this._lang.addInputButton +
          '</span>' +
          '<div class="content-engage-clear"></div>'
      );
      this.addInputObject = jQuery("#" + this.addInputID);

      var objectInstance = this;

      this.addInputObject.bind("click", function() {
        jQuery(this).hide();
        objectInstance._addField('', objectInstance.newFieldInputGroupName + '[]');
        jQuery(this).fadeIn("slow");
      });
    },

    _existentInitialization : function() {
      var objectInstance = this;

      jQuery.each(this.existentEntries, function(entryKey, entry) {
        objectInstance._addField(
          entry.title,
          objectInstance.existentFieldInputGroupName + '[' + entry.id  + ']'
        );
      });
    },

    _addField : function(defaultValue, inputName) {
      var objectInstance     = this,
          currentTitleNumber = this.inputContainerObject.find(
          '> .' + this.inputGroupClass
          ).not(".removed").length + 1;

      this.inputContainerObject.append(
          '<div class="' + this.inputGroupClass + '" style="display:none;">' +
            '<label>' + currentTitleNumber + '</label>' +
            '<input type="text" ' +
                   'name="' + inputName + '" ' +
                   'value="' + defaultValue + '"' +
                   'placeholder="' + this._lang.titlePlaceholder + '"' +
                   '/>' +
          '</div>'
      );

      if(this.inputContainerObject.find('> .' + this.inputGroupClass).length == 1) {
        this.inputContainerObject
            .find('> .' + this.inputGroupClass + ' input')
            .bind("keyup change", function(){
              objectInstance.mainController
                            .postTitleInputObject
                            .val(jQuery(this).val());
        });
      } else {
        var lastInputContainer = this.inputContainerObject
                                     .find('> .' + this.inputGroupClass)
                                     .last();
        lastInputContainer.addClass(this.deletableInputGroupClass);
        lastInputContainer.append(
            '<span class="' + this.deleteInputGroupClass + ' button button-default">' +
                this._lang.removeOption +
            '</span>'
        );

        lastInputContainer.find("." + this.deleteInputGroupClass).bind("click", function() {
          lastInputContainer.slideUp("slow", function(){
            lastInputContainer.find('> input').val("");
            lastInputContainer.addClass("removed");
          });
        });
      }

      this.inputContainerObject
          .find('> .' + this.inputGroupClass)
          .last().slideDown("slow");

      if(objectInstance.containerObject.is(":visible"))
        this._arrangeFieldContainers();
    },

    _arrangeFieldContainers : function() {
      this.inputContainerObject.find('> .' + this.inputGroupClass).each(function(){
        var elementWidth = 0;

        jQuery(this).find("> *:not(input)").each(function(){
          elementWidth += parseInt(jQuery(this).outerWidth(true), 10);
        });

        jQuery(this).find("input").css(
            "width", parseInt(jQuery(this).width(), 10) - elementWidth - 5
        );
      });
    }

  },

  InitializationController : {

    _lang : {
      initializationButton : 'Use Content Engage'
    },

    mainController      : {},
    wrapperID           : 'content-engage-initialization-wrapper',
    wrapperObject       : {},
    operationInitID     : 'content-engage-initialization-trigger',
    operationInitObject : {},

    Init : function(mainController) {
      this.mainController = mainController;

      this._setWrapper();
      this._setWrapperOperations();
    },

    _setWrapper : function() {
      this.mainController.titleWrapperObject.after(
          '<div id="' + this.wrapperID + '"></div>'
      );
      this.wrapperObject = jQuery("#" + this.wrapperID);
    },

    _setWrapperOperations : function() {
      var objectInstance = this;

      this.wrapperObject.append(
          "<span id='" + this.operationInitID + "' " +
                "class='button button-primary right'>" +
              this._lang.initializationButton +
          "</span>"
      );
      this.operationInitObject = jQuery('#' + this.operationInitID);
      this.operationInitObject.bind("click", function(){
        objectInstance.wrapperObject.fadeOut("slow");
        objectInstance.mainController.InterfaceController.Init(
            objectInstance.mainController
        );
      });
    }

  }

};

jQuery(document).ready(function(){
  ContentEngagePostPage.Init();
});