var ContentEngagePostPageImage = {

  imageWrapperID              : 'postimagediv',
  imageWrapperObject          : {},

  Init : function() {
    this.imageWrapperObject   = jQuery('#' + this.imageWrapperID);

    if(this.imageWrapperObject.length == 0)
      return;

    if(imageList.length > 0) {
      this.InterfaceController.Init(this, imageList);
    } else {
      this.InitializationController.Init(this);
    }
  },

  InterfaceController : {

    _lang : {
      addInputButton   : 'Add another image',
      imagePlaceholder : 'Your desired image',
      removeOption     : 'Remove',
      title            : 'Featured Image - Content Engage Split Testing',
      mention          : 'Image Split Testing will be active only if it is already verdicted, or if the title split testing is not active'
    },

    mainController    : {},

    containerID          : 'content-engage-image-interface-container',
    containerObject      : {},
    inputContainerID     : 'content-engage-image-interface-input-container',
    inputContainerObject : {},
    addInputID           : 'content-engage-image-interface-add-input',
    addInputObject       : {},

    inputGroupClass          : 'content-engage-image-interface-input-group',
    deletableInputGroupClass : 'content-engage-image-interface-deletable-input-group',
    deleteInputGroupClass    : 'content-engage-image-interface-delete-input-group',

    newFieldInputGroupName      : 'content_engage_image_field_new',
    existentFieldInputGroupName : 'content_engage_image_field_existent',

    existentEntries : [],

    sendToEditorTemporaryCopy : {},

    Init : function(mainController, existentEntries) {
      this.mainController  = mainController;
      this.existentEntries = (typeof existentEntries === "undefined" ? [] : existentEntries);

      this.mainController.imageWrapperObject.prependTo("#postbox-container-2");
      this.mainController.imageWrapperObject.find("> h3")
                                            .removeClass("hnadle ui-sortable-handle")
                                            .html(this._lang.title);
      jQuery("#set-post-thumbnail").hide();

      this._setContainer();

      if(this.existentEntries.length == 0) {
        this._addField(
            '',
            this.newFieldInputGroupName + '[]'
        );
      } else {
        this._existentInitialization();
      }

      var objectInstance = this;

      objectInstance.containerObject.fadeIn("slow", function(){
        objectInstance._arrangeFieldContainers();
      });

      this.inputContainerObject.on("click", 'input[type="text"]', function(event){
        var inputObject = jQuery(this);
        console.log(inputObject.html());
        objectInstance.sendToEditorTemporaryCopy = window.send_to_editor;

        window.send_to_editor = function(html) {
          inputObject.val(jQuery('img', html).attr('src')).trigger("change");
          tb_remove();
          window.send_to_editor = objectInstance.sendToEditorTemporaryCopy;
          objectInstance._arrangeFieldContainers();
        };

        tb_show( '', 'media-upload.php?type=image&amp;TB_iframe=true' );

        return false;
      });

      jQuery(window).resize(function(){
        objectInstance._arrangeFieldContainers();
      });
    },

    _setContainer : function() {
      this.mainController.imageWrapperObject.find("> .inside").append(
          '<div id="' + this.containerID + '" style="display:none;"></div>'
      );
      this.containerObject = jQuery("#" + this.containerID);

      this.containerObject.append(
          '<div id="' + this.inputContainerID + '"></div>'
      );
      this.inputContainerObject = jQuery("#" + this.inputContainerID);

      this.containerObject.append(
          '<span id="' + this.addInputID + '" class="button button-default right">' +
            this._lang.addInputButton +
          '</span>' +
          '<div class="content-engage-clear"></div>'
      );
      this.addInputObject = jQuery("#" + this.addInputID);

      var objectInstance = this;

      this.addInputObject.bind("click", function() {
        jQuery(this).hide();
        objectInstance._addField('', objectInstance.newFieldInputGroupName + '[]');
        jQuery(this).fadeIn("slow");
      });
    },

    _existentInitialization : function() {
      var objectInstance = this;

      jQuery.each(this.existentEntries, function(entryKey, entry) {
        objectInstance._addField(
          entry.image,
          objectInstance.existentFieldInputGroupName + '[' + entry.id  + ']'
        );
      });
    },

    _addField : function(defaultValue, inputName) {
      var objectInstance     = this,
          currentImageNumber = this.inputContainerObject.find(
          '> .' + this.inputGroupClass
          ).not(".removed").length + 1;

      this.inputContainerObject.append(
          '<div class="' + this.inputGroupClass + '" style="display:none;">' +
            '<label>' + currentImageNumber + '</label>' +
            '<input type="text" ' +
                   'name="' + inputName + '" ' +
                   'value="' + defaultValue + '"' +
                   'placeholder="' + this._lang.imagePlaceholder + '"' +
                   '/>' +
          '</div>'
      );

      if(!(this.inputContainerObject.find('> .' + this.inputGroupClass).length == 1)) {
        var lastInputContainer = this.inputContainerObject
                                     .find('> .' + this.inputGroupClass)
                                     .last();
        lastInputContainer.addClass(this.deletableInputGroupClass);
        lastInputContainer.append(
            '<span class="' + this.deleteInputGroupClass + ' button button-default">' +
                this._lang.removeOption +
            '</span>'
        );

        lastInputContainer.find("." + this.deleteInputGroupClass).bind("click", function() {
          lastInputContainer.slideUp("slow", function(){
            lastInputContainer.find('> input').val("");
            lastInputContainer.addClass("removed");
          });
        });
      }

      this.inputContainerObject
          .find('> .' + this.inputGroupClass)
          .last().slideDown("slow");

      if(objectInstance.containerObject.is(":visible"))
        this._arrangeFieldContainers();
    },

    _arrangeFieldContainers : function() {
      this.inputContainerObject.find('> .' + this.inputGroupClass).each(function(){
        var elementWidth = 0;

        jQuery(this).find("> *:not(input)").each(function(){
          elementWidth += parseInt(jQuery(this).outerWidth(true), 10);
        });

        jQuery(this).find("input").css(
            "width", parseInt(jQuery(this).width(), 10) - elementWidth - 5
        );
      });
    }

  },

  InitializationController : {

    _lang : {
      initializationButton : 'Use Content Engage'
    },

    mainController      : {},
    wrapperID           : 'content-engage-image-initialization-wrapper',
    wrapperObject       : {},
    operationInitID     : 'content-engage-image-initialization-trigger',
    operationInitObject : {},

    Init : function(mainController) {
      this.mainController = mainController;

      this._setWrapper();
      this._setWrapperOperations();
    },

    _setWrapper : function() {
      this.mainController.imageWrapperObject.find(" > .inside").append(
          '<p id="' + this.wrapperID + '"></p>'
      );
      this.wrapperObject = jQuery("#" + this.wrapperID);
    },

    _setWrapperOperations : function() {
      var objectInstance = this;

      this.wrapperObject.append(
          "<span id='" + this.operationInitID + "' " +
                "class='button button-primary right'>" +
              this._lang.initializationButton +
          "</span>"
      );
      this.operationInitObject = jQuery('#' + this.operationInitID);
      this.operationInitObject.bind("click", function(){
        objectInstance.wrapperObject.fadeOut("slow");
        objectInstance.mainController.InterfaceController.Init(
            objectInstance.mainController
        );
      });
    }

  }

};

jQuery(document).ready(function(){
  ContentEngagePostPageImage.Init();
});