<?php

class ContentEngageSettings {

  public $settingPrefix = 'content_engage_';

  public $settingHomepageTestMode            = 'homepage_test_mode';
  public $settingAutomaticTitleAssociation   = 'automatic_title_association';
  public $settingAutomaticTitleAssociationMode   = 'automatic_title_association_mode';
  public $settingAutomaticExcerptAssociation = 'automatic_excerpt_association';
  public $settingDefaultSplitTestingMargin   = 'default_split_testing_margin';

  public $homepageTestMode              = 0;
  public $automaticTitleAssociation     = 0;
  public $automaticTitleAssociationMode = 'database';
  public $automaticExcerptAssociation   = 0;
  public $defaultSplitTestingMargin     = 100;

  public function __construct() {
    $this->_prefixSettings();
    $this->_setSettings();
  }

  private function _prefixSettings() {
    $this->settingHomepageTestMode            = $this->settingPrefix . $this->settingHomepageTestMode;
    $this->settingAutomaticTitleAssociation   = $this->settingPrefix . $this->settingAutomaticTitleAssociation;
    $this->settingDefaultSplitTestingMargin   = $this->settingPrefix . $this->settingDefaultSplitTestingMargin;
    $this->settingAutomaticExcerptAssociation = $this->settingPrefix . $this->settingAutomaticExcerptAssociation;
    $this->settingAutomaticTitleAssociationMode = $this->settingPrefix . $this->settingAutomaticTitleAssociationMode;
  }

  private function _setSettings() {
    $this->homepageTestMode            = get_option($this->settingHomepageTestMode, $this->homepageTestMode);
    $this->automaticTitleAssociation   = get_option($this->settingAutomaticTitleAssociation, $this->automaticTitleAssociation);
    $this->defaultSplitTestingMargin   = get_option($this->settingDefaultSplitTestingMargin, $this->defaultSplitTestingMargin);
    $this->automaticExcerptAssociation = get_option($this->settingAutomaticExcerptAssociation, $this->automaticExcerptAssociation);
    $this->automaticTitleAssociationMode = get_option($this->settingAutomaticTitleAssociationMode, $this->automaticTitleAssociationMode);
  }

  public function setHomepageTestMode($homepageTestMode) {
    $this->homepageTestMode = $homepageTestMode;
    update_option($this->settingHomepageTestMode, $this->homepageTestMode);
  }

  public function setAutomaticTitleAssociation($automaticTitleAssociation) {
    $this->automaticTitleAssociation = $automaticTitleAssociation;
    update_option($this->settingAutomaticTitleAssociation, $this->automaticTitleAssociation);
  }

  public function setAutomaticTitleAssociationMode($automaticTitleAssociationMode) {
    $this->automaticTitleAssociationMode = $automaticTitleAssociationMode;
    update_option($this->settingAutomaticTitleAssociationMode, $this->automaticTitleAssociationMode);
  }

  public function setDefaultSplitTestingMargin($defaultSplitTestingMargin) {
    $this->defaultSplitTestingMargin = $defaultSplitTestingMargin;
    update_option($this->settingDefaultSplitTestingMargin, $this->defaultSplitTestingMargin);
  }

  public function setAutomaticExcerptAssociation($automaticExcerptAssociation) {
    $this->automaticExcerptAssociation = $automaticExcerptAssociation;
    update_option($this->settingAutomaticExcerptAssociation, $this->automaticExcerptAssociation);
  }
}