<?php

class ContentEngageVersionControl {

  public $wpOptionDatabaseVersion = 'database_version';
  public $currentDatabaseVersion  = '1.1';

  public $databaseUpdateVersion = array(
    '1.1' => '1.1.sql'
  );

  public function __construct($init = true) {
    $this->wpOptionDatabaseVersion = ContentEngageController::getInstance()->pluginPrefix . '_' . $this->wpOptionDatabaseVersion;

    if($init)
      $this->init();
  }

  public function init() {
    if(get_option($this->wpOptionDatabaseVersion) != $this->currentDatabaseVersion)
      foreach($this->databaseUpdateVersion as $versionAlias => $versionFile)
        if(floatval($versionAlias) > floatval(get_option($this->wpOptionDatabaseVersion)))
          $this->_updateDatabaseToVersion($versionAlias, $versionFile);

  }

  private function _updateDatabaseToVersion($versionAlias, $versionFile) {
    global $wpdb;

    $query = file_get_contents(
        ContentEngageController::getInstance()->pluginFilePath
        . 'model/sql-update/'
        . $versionFile
    );

    if($query == false)
      throw new Exception(ContentEngageController::getInstance()->pluginName . ', missing DB UPDATE File');

    $query = str_replace('content_engage_' , $wpdb->base_prefix . 'content_engage_', $query);
    $queries = explode(';', $query);


    foreach($queries as $query)
      if(strlen($query)> 20)
        $response = $wpdb->query($query);

    $this->setCurrentDatabaseVersion($versionAlias);
  }

  public function setCurrentDatabaseVersion($currentVersion) {
    $this->currentDatabaseVersion = $currentVersion;
    update_option($this->wpOptionDatabaseVersion, $this->currentDatabaseVersion);
  }

}