<?php
  $postID               = intval($_GET['post-id']);
  $chartInformation     = ContentEngageController::getInstance()
                            ->entityPostTitle
                            ->getPostTitleListWithInformation($postID);
?>

<a href="?page=<?php echo ContentEngageController::getInstance()->pluginSlug;?>" class="btn btn-success">
  &laquo;
  <?php echo __("Back");?>
</a>

<a href="?page=<?php echo ContentEngageController::getInstance()->pluginSlug;?>&sub-page=view&post-id=<?php echo $postID;?>"
   class="btn btn-primary">
  <?php echo __("Table Statistics");?>
</a>

<div class="clearfix"></div>
<br/>

<div class="row">
  <div class="col-md-6">
    <h2>Views</h2>
    <canvas id="content_engage-views-chart" width="500" height="400"></canvas>
  </div>
  <div class="col-md-6">
    <h2>Unique Views</h2>
    <canvas id="content_engage-unique-views-chart" width="500" height="400"></canvas>
  </div>
  <div class="col-md-6">
    <h2>Inbound Traffic</h2>
    <canvas id="content_engage-inbound-chart" width="500" height="400"></canvas>
  </div>
  <div class="col-md-6">
    <h2>Assigned Traffic</h2>
    <canvas id="content_engage-assigned-chart" width="500" height="400"></canvas>
  </div>
</div>

<script type="text/javascript">
  jQuery(document).ready(function(){
    var chartObject = jQuery("#content_engage-views-chart");
    chartObject.attr('width', chartObject.parent().width());

    var data = [
      <?php $i = 0;foreach($chartInformation as $titleInformation) : ?>
      <?php $colorSet = ContentEngageController::getInstance()->chartStatisticsColors[$i];?>
      {
        value     : <?php echo $titleInformation->displays;?>,
        color     : "<?php echo $colorSet['default']?>",
        highlight : "<?php echo $colorSet['hover']?>",
        label     : "<?php echo $titleInformation->title;?>"
      },
      <?php $i++;endforeach; ?>
    ];

    var ctx = document.getElementById("content_engage-views-chart").getContext("2d");
    new Chart(ctx).PolarArea(data);

    // Unique Views Chart

    var uniqueViewsChartObject = jQuery("#content_engage-unique-views-chart");
    uniqueViewsChartObject.attr('width', chartObject.parent().width());

    var uniqueViewsData = [
      <?php $i = 0;foreach($chartInformation as $titleInformation) : ?>
      <?php $colorSet = ContentEngageController::getInstance()->chartStatisticsColors[$i];?>
      {
        value     : <?php echo $titleInformation->uniqueDisplays;?>,
        color     : "<?php echo $colorSet['default']?>",
        highlight : "<?php echo $colorSet['hover']?>",
        label     : "<?php echo $titleInformation->title;?>"
      },
      <?php $i++;endforeach; ?>
    ];

    var uniqueViewsCTX = document.getElementById("content_engage-unique-views-chart").getContext("2d");
    new Chart(uniqueViewsCTX).PolarArea(uniqueViewsData);

    // Inbound Traffic Chart

    var inboundChartObject = jQuery("#content_engage-inbound-chart");
    inboundChartObject.attr('width', chartObject.parent().width());

    var inboundData = [
      <?php $i = 0;foreach($chartInformation as $titleInformation) : ?>
      <?php $colorSet = ContentEngageController::getInstance()->chartStatisticsColors[$i];?>
      {
        value     : <?php echo ($titleInformation->uniqueDisplays - $titleInformation->uniqueAssigns > 0 ? $titleInformation->uniqueDisplays - $titleInformation->uniqueAssigns : 0);?>,
        color     : "<?php echo $colorSet['default']?>",
        highlight : "<?php echo $colorSet['hover']?>",
        label     : "<?php echo $titleInformation->title;?>"
      },
      <?php $i++;endforeach; ?>
    ];

    var inboundCTX = document.getElementById("content_engage-inbound-chart").getContext("2d");
    new Chart(inboundCTX).PolarArea(inboundData);

    // Assigned Traffic Chart

    var assignedChartObject = jQuery("#content_engage-assigned-chart");
    assignedChartObject.attr('width', chartObject.parent().width());

    var assignedData = [
      <?php $i = 0;foreach($chartInformation as $titleInformation) : ?>
      <?php $colorSet = ContentEngageController::getInstance()->chartStatisticsColors[$i];?>
      {
        value     : <?php echo $titleInformation->assigns;?>,
        color     : "<?php echo $colorSet['default']?>",
        highlight : "<?php echo $colorSet['hover']?>",
        label     : "<?php echo $titleInformation->title;?>"
      },
      <?php $i++;endforeach; ?>
    ];

    var assignedCTX = document.getElementById("content_engage-assigned-chart").getContext("2d");
    new Chart(assignedCTX).PolarArea(assignedData);
  });
</script>